# File: Iso-pi demo python program.py
# working Raspi Iso-Pi I/O board test
# Brian Millier


from Tkinter import *
import tkFileDialog
import tkMessageBox
import time
import serial
import os.path
from array import *

#graphboxwidth = 700
#graphboxheight = 250

global abortflag
global entryWidget
global ADCval
global Encval
global PAval
global PBval
global z
global PortAMode
global PortBMode

global a7,a6,a5,a4,a3,a2,a1,a0
global b7,b6,b5,b4,b3,b2,b1,b0
global c7,c6,c5,c4,c3,c2,c1,c0
global kbdwin
global StepperRate,NumberSteps
global statusString

#sample= array('i')
#for i in range(1,1000):
#sample.append(i)

NumberSteps=1
StepperRate=1000 #1000 us = 1 ms

PortAMode=0   # match PortA mode to input (power on state of I/O board)
PortBMode=0   # match PortB mode to input (power on state of I/O board)

def LoadDACA(event):
        n=float(event) 
        n=n * 1996.6   #2.051 volts= 4095
        n=int(n)
        p=str(n)
        p="DA " + p 
        SendCommand1(p)
        
def LoadDACB(event):
        n=float(event)
        n=n * 1996.6   #2.051 volts= 4095
        n=int(n)        
        p=str(n)
        p="DB " + p
        SendCommand1(p)

def InitServo():
        p="SI"
        SendCommand1(p)
        
def LoadServo(event):
        n=float(event)      
        p=str(n)
        p="SS " + p 
        SendCommand1(p)

def LoadStepperRate(event):
        global StepperRate     
        n=int(event)
        n=n*1000
        StepperRate=n

def LoadNumberSteps(event):
        global NumberSteps
        n=int(event)
        NumberSteps=n

def MoveStepper():
        global StepperRate, NumberSteps
        if NumberSteps == 0:
            NumberSteps= 1
        p= "BS " + str(NumberSteps)
        SendCommand1(p)
        p= "BT " + str(StepperRate)
        SendCommand1(p)
        p="BM"
        SendCommand1(p)

def StepCW():
      p= "BF"
      SendCommand1(p)      

def StepCCW():
      p= "BR"
      SendCommand1(p)
        
def SetMotorASpeed(event):        
        p="MAS " + event
        SendCommand1(p)

def SetMotorBSpeed(event):        
        p="MBS " + event
        SendCommand1(p)

def SetMotorAForward():
        p="MAF"
        SendCommand1(p)
        
def SetMotorAReverse():
        p="MAR"
        SendCommand1(p)

def SetMotorABrake():
        p="MAB"
        SendCommand1(p)

def SetMotorBForward():
        p="MBF"
        SendCommand1(p)
        
def SetMotorBReverse():
        p="MBR"
        SendCommand1(p)

def SetMotorBBrake():
        p="MBB"
        SendCommand1(p)           
        
def PortARead():
        global PAval
        p="PAI"
        result=SendCommand2(p)
        PAval.set(result)

def PortBRead():
        global PBval
        p="PBI"
        result=SendCommand2(p)
        PBval.set(result)
        
def ReadEncoder():
        global Encval
        p="EV"
        result=SendCommand2(p)
        Encval.set(result)        
      
def ZeroEncoder():
        p= 'EZ'
        SendCommand1(p)
        Encval.set(0)

def ADCread():
        global ADCval
        p="AI"
        result=SendCommand2(p)
        ADCval.set(result)

        
def idroutine():
        p="?"
        result=SendCommand2(p)
        result= "Status: " + result
        statusString.set(result)    


def SendCommand1(cm):
    while COMM.inWaiting()  >0:
         COMM.read()
    print cm
    cm += '\r'
    COMM.write(cm)
    p=COMM.readline()
    if p != "OK\r\n":
        print p

def SendCommand2(cm):
    while COMM.inWaiting()  >0:
         COMM.read()
    print cm
    cm += '\r'
    COMM.write(cm)
    q=COMM.readline()
    r=q.rstrip("\n")
    p=COMM.readline()
    if p != "OK\r\n":
        print p          
    return r

def setADCch1():
    SendCommand1("AC0")
    
def setADCch2():
    SendCommand1("AC1")
    
def setADCch3():
    SendCommand1("AC2")
    
def setADCch4():
    SendCommand1("AC3")

def setADCgain1():
    SendCommand1("AG0")

def setADCgain2():
    SendCommand1("AG1")

def setADCgain4():
    SendCommand1("AG2")

def setADCgain8():
    SendCommand1("AG3")

def setADCrate1():
    SendCommand1("AR0")

def setADCrate2():
    SendCommand1("AR1")

def setADCrate3():
    SendCommand1("AR2")

def setADCrate4():
    SendCommand1("AR3")


def DisablePortACheckBoxes():    
    #DISABLE THE PORT A OUTPUT CHECKBOXES
    global c7,c6,c5,c4,c3,c2,c1,c0  
    c7.config(state=DISABLED)
    c6.config(state=DISABLED)
    c5.config(state=DISABLED)
    c4.config(state=DISABLED)
    c3.config(state=DISABLED)
    c2.config(state=DISABLED)
    c1.config(state=DISABLED)
    c0.config(state=DISABLED)

def EnablePortACheckBoxes():
    #ENABLE THE PORT A OUTPUT CHECKBOXES
    global c7,c6,c5,c4,c3,c2,c1,c0  
    c7.config(state=NORMAL)
    c6.config(state=NORMAL)
    c5.config(state=NORMAL)
    c4.config(state=NORMAL)
    c3.config(state=NORMAL)
    c2.config(state=NORMAL)
    c1.config(state=NORMAL)
    c0.config(state=NORMAL)      

def setPortAmode0():
    global PortAMode  
    DisablePortACheckBoxes()
    PortAMode=0  
    SendCommand1("PAM0") 

def setPortAmode1():
    global PortAMode  
    DisablePortACheckBoxes()
    PortAMode=1  
    SendCommand1("PAM1") 

def setPortAmode2():
    global PortAMode  
    DisablePortACheckBoxes()
    PortAMode=2  
    SendCommand1("PAM2") 

def setPortAmode3():
    global PortAMode  
    DisablePortACheckBoxes()
    PortAMode=3  
    SendCommand1("PAM3") 

def setPortAmode4():
    global PortAMode
    EnablePortACheckBoxes()
    PortAMode=4
    SendCommand1("PAM4")

def DisablePortBCheckBoxes():
    #DISABLE THE PORT B OUTPUT CHECKBOXES
    global d7,d6,d5,d4,d3,d2,d1,d0  
    d7.config(state=DISABLED)
    d6.config(state=DISABLED)
    d5.config(state=DISABLED)
    d4.config(state=DISABLED)
    d3.config(state=DISABLED)
    d2.config(state=DISABLED)
    d1.config(state=DISABLED)
    d0.config(state=DISABLED)

def EnablePortBCheckBoxes():
    #ENABLE THE PORT B OUTPUT CHECKBOXES
    global d7,d6,d5,d4,d3,d2,d1,d0  
    d7.config(state=NORMAL)
    d6.config(state=NORMAL)
    d5.config(state=NORMAL)
    d4.config(state=NORMAL)
    d3.config(state=NORMAL)
    d2.config(state=NORMAL)
    d1.config(state=NORMAL)
    d0.config(state=NORMAL)
      
    
def setPortBmode0():
    global PortBMode
    DisablePortBCheckBoxes()
    PortBMode=0  
    SendCommand1("PBM0") 

def setPortBmode1():
    global PortBMode
    DisablePortBCheckBoxes()
    PortBMode=1  
    SendCommand1("PBM1") 

def setPortBmode2():
    global PortBMode
    DisablePortBCheckBoxes()    
    PortBMode=2  
    SendCommand1("PBM2") 

def setPortBmode3():
    global PortBMode
    DisablePortBCheckBoxes()    
    PortBMode=3  
    SendCommand1("PBM3") 

def setPortBmode4():
    global PortBMode  
    EnablePortBCheckBoxes()  
    PortBMode=4  
    SendCommand1("PBM4")

def portAout():
          global PortAMode
          if PortAMode ==4:            
                PortAValue= (a7.get() <<7) + (a6.get() <<6) + (a5.get() <<5) +(a4.get() <<4) \
                + (a3.get() <<3) + (a2.get() <<2) + (a1.get() <<1) + a0.get()
                p="PAO " +str(PortAValue)
                SendCommand1(p)
                
def portBout():
          global PortBMode
          if PortBMode ==4:            
                PortBValue= (b7.get() <<7) + (b6.get() <<6) + (b5.get() <<5) +(b4.get() <<4) \
                + (b3.get() <<3) + (b2.get() <<2) + (b1.get() <<1) + b0.get()
                p="PBO " +str(PortBValue)
                SendCommand1(p)

def portCout():
          PortCValue= (e7.get() <<7) + (e6.get() <<6) + (e5.get() <<5) +(e4.get() <<4) \
          + (e3.get() <<3) + (e2.get() <<2) + (e1.get() <<1) + e0.get()
          p="C " +str(PortCValue)
          SendCommand1(p)
                
                
def quithandler():
    ms= "Are you Sure you want to quit?"
    ans= tkMessageBox.askyesno("ALERT",ms)
    if ans == True :
          root.destroy()

def StartKeyPadScan():
     global AbortFlag
     AbortFlag=0
     SendCommand1("KI")  # set up PortA for scanning
     while AbortFlag == 0:
         kp = SendCommand2("KF")  # Poll keyboard - no blocking - returns 0 if no key pressed
         keyval=int(kp)       
         frame.update()
         if keyval != 0 :
            result= "Keycode= " + kp
         else:
            result = "No Keys Pressed"
            
         statusString.set(result)
         
     SendCommand1("KR")   # restore PortA to default input mode 
      

def StopKeyPadScan():
      global AbortFlag
      AbortFlag=1
        

root = Tk()
root.title("Raspi Isolated I/O Board Test")
root.protocol("WM_DELETE_WINDOW",quithandler)

COMM= serial.Serial('/dev/ttyAMA0',115200,timeout=4)
COMM.open

var = IntVar()
abortflag= False
#  create a menu
menu = Menu(root,tearoff=0)
root.config(menu=menu)
filemenu = Menu(menu,tearoff=0)
menu.add_cascade(label="File", menu=filemenu) 
filemenu.add_command(label="Exit", command=quithandler)
ADCmenu=Menu(menu,tearoff=0)
menu.add_cascade(label="ADC Config", menu=ADCmenu)
chanmenu=Menu(ADCmenu,tearoff=0)
chanmenu.add_command(label="CH1", command= setADCch1)
chanmenu.add_command(label="CH2", command= setADCch2)
chanmenu.add_command(label="CH3", command= setADCch3)
chanmenu.add_command(label="CH4", command= setADCch4)
ADCmenu.add_cascade(label="Channel", menu=chanmenu)

gainmenu=Menu(ADCmenu)
gainmenu.add_command(label="Gain=1", command= setADCgain1)
gainmenu.add_command(label="GAIN=2", command= setADCgain2)
gainmenu.add_command(label="GAIN=4", command= setADCgain4)
gainmenu.add_command(label="GAIN=8", command= setADCgain8)
ADCmenu.add_cascade(label="Gain", menu=gainmenu)

ratemenu=Menu(ADCmenu)
ratemenu.add_command(label="Rate = 3.75 SPS", command= setADCrate4)
ratemenu.add_command(label="Rate = 15 SPS", command= setADCrate3)
ratemenu.add_command(label="Rate = 60 SPS", command= setADCrate2)
ratemenu.add_command(label="Rate = 240 SPS", command= setADCrate1)
ADCmenu.add_cascade(label="Rate", menu=ratemenu)

PortAmenu=Menu(menu,tearoff=0)
menu.add_cascade(label="PortA Config", menu=PortAmenu)
PortAmenu.add_command(label="INPUT,No Pullup,No Inversion.", command= setPortAmode0)
PortAmenu.add_command(label="INPUT,No Pullup,Inversion", command= setPortAmode1)
PortAmenu.add_command(label="INPUT,Pullup, No Inversion", command= setPortAmode2)
PortAmenu.add_command(label="INPUT,Pullup,Inversion", command= setPortAmode3)
PortAmenu.add_command(label="OUTPUT", command= setPortAmode4)

PortBmenu=Menu(menu,tearoff=0)
menu.add_cascade(label="PortB Config", menu=PortBmenu)
PortBmenu.add_command(label="INPUT,No Pullup,No Inversion.", command= setPortBmode0)
PortBmenu.add_command(label="INPUT,No Pullup,Inversion", command= setPortBmode1)
PortBmenu.add_command(label="INPUT,Pullup, No Inversion", command= setPortBmode2)
PortBmenu.add_command(label="INPUT,Pullup,Inversion", command= setPortBmode3)
PortBmenu.add_command(label="OUTPUT", command= setPortBmode4)

MotorAmenu=Menu(menu,tearoff=0)
menu.add_cascade(label="MotorA Control", menu=MotorAmenu)
MotorAmenu.add_command(label="Forward", command= SetMotorAForward)
MotorAmenu.add_command(label="Reverse", command= SetMotorAReverse)
MotorAmenu.add_command(label="Brake", command= SetMotorABrake)

MotorBmenu=Menu(menu,tearoff=0)
menu.add_cascade(label="MotorB Control", menu=MotorBmenu)
MotorBmenu.add_command(label="Forward", command= SetMotorBForward)
MotorBmenu.add_command(label="Reverse", command= SetMotorBReverse)
MotorBmenu.add_command(label="Brake", command= SetMotorBBrake)

KeyPadmenu=Menu(menu,tearoff=0)
menu.add_cascade(label="Keypad Routines", menu=KeyPadmenu)
KeyPadmenu.add_command(label="Start Scanning", command= StartKeyPadScan)
KeyPadmenu.add_command(label="Stop Scanning", command= StopKeyPadScan)

frame = Frame(root)
frame.grid(row=0,column=0)
z1= Button(frame, text="Zero Encoder", command=ZeroEncoder)
z1.grid(row=0,column=0,columnspan=4)
z2= Button(frame, text="Read Encoder", command=ReadEncoder)
z2.grid(row=1,column=0,columnspan=4)
Encval=StringVar()
l2=Label(frame,textvariable =Encval, height=1, width=8, bg="WHITE").grid(row=2,column=0,columnspan=4)
Encval.set("----")        
bm = Button(frame, text="ADC Read", command=ADCread).grid(row=3,column=0,columnspan=4)
ADCval=StringVar()
l=Label(frame,textvariable =ADCval, height=1, width=8, bg="WHITE").grid(row=4,column=0,columnspan=4)
ADCval.set("---")
PAReadBut=Button(frame, text="PortA Read", command= PortARead)
PAReadBut.grid(row=0,column=4,columnspan=4)
PAval= StringVar()
PAReadLabel = Label(frame,textvariable = PAval, width=8, bg="WHITE")
PAval.set("---")
PAReadLabel.grid(row=1,column=4,columnspan=3)
PBReadBut=Button(frame, text="PortB Read", command= PortBRead)
PBReadBut.grid(row=2,column=4,columnspan=4)
PBval= StringVar()
PBReadLabel = Label(frame,textvariable = PBval, width=8, bg="WHITE")
PBval.set("---")
PBReadLabel.grid(row=3,column=4,columnspan=3)
idbut = Button(frame, text="Identify board",width=14, command=idroutine)
idbut.grid(row=3,column=12,columnspan=4)
h1=Button(frame, text = "S.Step CW", width = 8, state=NORMAL, command= StepCW)
h1.grid(row=0,column=9,rowspan=1)
h2=Button(frame, text = "S.Step CCW", width = 8, state=NORMAL, command= StepCCW)
h2.grid(row=0,column=10)

stepbut = Button(frame, text="Move Stepper",width=10, command=MoveStepper)
stepbut.grid(row=1,column=8,columnspan=4)
sc6= Scale(frame,from_ = 1, to=32, command= LoadStepperRate, orient=HORIZONTAL,label="Step Rate (ms)",tickinterval=16)
sc6.grid(row=2,column=8,columnspan=4)
sc7= Scale(frame,from_ = -200,to=200,command= LoadNumberSteps, orient=HORIZONTAL,label="# of Steps",tickinterval=200)
sc7.grid(row=3,column=8,columnspan=4)
sc1 = Scale(frame,from_ = 0,to= 2.05, resolution=0.01,command=LoadDACA, orient=HORIZONTAL,label="Load DACA",tickinterval=1.0)
sc1.grid(row=0,column=12,columnspan=4)
sc2= Scale(frame,from_ = 0,to=2.05,resolution= 0.01,command=LoadDACB, orient=HORIZONTAL,label="Load DACB",tickinterval=1.0)
sc2.grid(row=2,column=12,columnspan=4)
sc3= Scale(frame,from_ = 0,to=100,resolution= 0.1,command= LoadServo, orient=HORIZONTAL,label="Set Servo",tickinterval=100)
sc3.grid(row=0,column=17,columnspan=4)
servoinitbut = Button(frame,text="Initialize Servo",command=InitServo)
servoinitbut.grid(row=1,column=17,columnspan=4)
sc4= Scale(frame,from_ = 0,to=255,resolution= 1,command= SetMotorASpeed, orient=HORIZONTAL,label="MotorA Speed",tickinterval=255)
sc4.grid(row=2,column=17,columnspan=4)
sc5= Scale(frame,from_ = 0,to=255,resolution= 1,command= SetMotorBSpeed, orient=HORIZONTAL,label="MotorB Speed",tickinterval=255)
sc5.grid(row=3,column=17,columnspan=4)


a0 = IntVar()
a1 = IntVar()
a2 = IntVar()
a3 = IntVar()
a4 = IntVar()
a5 = IntVar()
a6 = IntVar()
a7 = IntVar()
PAlabel = Label(frame,text="PORTA output",pady=2).grid(row=5,column=0,columnspan=3)
c7=Checkbutton(frame, text = "7", width = 1, var=a7,state=DISABLED, command= portAout)
c7.grid(row=5,column=3)
c6=Checkbutton(frame, text = "6", width = 1, var=a6,state=DISABLED, command= portAout)
c6.grid(row=5,column=4)
c5=Checkbutton(frame, text = "5", width = 1, var=a5,state=DISABLED, command= portAout)
c5.grid(row=5,column=5)
c4=Checkbutton(frame, text = "4", width = 1, var=a4,state=DISABLED, command= portAout)
c4.grid(row=5,column=6)
c3=Checkbutton(frame, text = "3", width = 1, var=a3,state=DISABLED, command= portAout)
c3.grid(row=5,column=7)
c2=Checkbutton(frame, text = "2", width = 1, var=a2,state=DISABLED, command= portAout)
c2.grid(row=5,column=8)
c1=Checkbutton(frame, text = "1", width = 1, var=a1,state=DISABLED, command= portAout)
c1.grid(row=5,column=9)
c0=Checkbutton(frame, text = "0", width = 1, var=a0,state=DISABLED, command= portAout)
c0.grid(row=5,column=10)
    
b0 = IntVar()
b1 = IntVar()
b2 = IntVar()
b3 = IntVar()
b4 = IntVar()
b5 = IntVar()
b6 = IntVar()
b7 = IntVar()
PBlabel = Label(frame,text="PORT B Output",pady=2).grid(row=5,column=12,columnspan=3)
d7=Checkbutton(frame, text = "7", width = 1, var=b7,state=DISABLED, command= portBout)
d7.grid(row=5,column=15)
d6=Checkbutton(frame, text = "6", width = 1, var=b6,state=DISABLED, command= portBout)
d6.grid(row=5,column=16)
d5=Checkbutton(frame, text = "5", width = 1, var=b5,state=DISABLED, command= portBout)
d5.grid(row=5,column=17)
d4=Checkbutton(frame, text = "4", width = 1, var=b4,state=DISABLED, command= portBout)
d4.grid(row=5,column=18)
d3=Checkbutton(frame, text = "3", width = 1, var=b3,state=DISABLED, command= portBout)
d3.grid(row=5,column=19)
d2=Checkbutton(frame, text = "2", width = 1, var=b2,state=DISABLED, command= portBout)
d2.grid(row=5,column=20)
d1=Checkbutton(frame, text = "1", width = 1, var=b1,state=DISABLED, command= portBout)
d1.grid(row=5,column=21)
d0=Checkbutton(frame, text = "0", width = 1, var=b0,state=DISABLED, command= portBout)
d0.grid(row=5,column=22)

e0 = IntVar()
e1 = IntVar()
e2 = IntVar()
e3 = IntVar()
e4 = IntVar()
e5 = IntVar()
e6 = IntVar()
e7 = IntVar()
PClabel = Label(frame,text="PORT C Output",pady=2).grid(row=6,column=0,columnspan=3)
f7=Checkbutton(frame, text = "7", width = 1, var=e7,state=NORMAL, command= portCout)
f7.grid(row=6,column=3)
f6=Checkbutton(frame, text = "6", width = 1, var=e6,state=NORMAL, command= portCout)
f6.grid(row=6,column=4)
f5=Checkbutton(frame, text = "5", width = 1, var=e5,state=NORMAL, command= portCout)
f5.grid(row=6,column=5)
f4=Checkbutton(frame, text = "4", width = 1, var=e4,state=NORMAL, command= portCout)
f4.grid(row=6,column=6)
f3=Checkbutton(frame, text = "3", width = 1, var=e3,state=NORMAL, command= portCout)
f3.grid(row=6,column=7)
f2=Checkbutton(frame, text = "2", width = 1, var=e2,state=NORMAL, command= portCout)
f2.grid(row=6,column=8)
f1=Checkbutton(frame, text = "1", width = 1, var=e1,state=NORMAL, command= portCout)
f1.grid(row=6,column=9)
f0=Checkbutton(frame, text = "0", width = 1, var=e0,state=NORMAL, command= portCout)
f0.grid(row=6,column=10)

statusString = StringVar()
statusLabel = Label(frame,textvariable = statusString, width=30, bg="WHITE",anchor=W)
statusLabel.grid(row=6,column=15,columnspan=8)
statusString.set("Status")

root.mainloop()
